unit uStickyForm;

interface

uses
  Types,  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Buttons, Dialogs, ExtCtrls, StdCtrls, uConst, OleCtrls;

type
  TfrmStickyForm = class(TForm)
    lSmile: TLabel;
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  //       TButton         
  TbtnTestButton = class(TButton)
  private
    class procedure HelloOnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  end;


  function PluginInit(dwThisPluginID : DWORD; plInfo : PPluginInfo; func1 : TtypeClCommFortProcess; func2 : TtypeClGetData) : BYTE; cdecl; stdcall;
  function PluginTerminate : BYTE; cdecl; stdcall;
  procedure PluginShowOptions; cdecl; stdcall;
  procedure PluginShowAbout; cdecl; stdcall;
  function PluginProcess(dwMessageID : DWORD; bMessage : PString; dwMessageLength : DWORD) : BYTE; cdecl; stdcall;
  function CommFortAskData(AskType : Byte) : String;
  procedure pUsrsInChan(Msg : TStringStream);
  function WndHook(CODE, WParam, LParam: DWORD): DWORD; stdcall;

  exports PluginInit, PluginTerminate, PluginProcess, PluginShowOptions, PluginShowAbout;

const STICKY_CHANNEL_HEIGHT = 50; //     ,           0
      STICKY_CHANNEL_NAME = 'sticky'; //     
var
  dwPluginID      : DWORD;
  CommFortProcess : TtypeClCommFortProcess;
  CommFortGetData : TtypeClGetData;
  frmStickyForm: TfrmStickyForm;
  ChannelsCount : Integer = 0; //   .            
  ChatWindow : HWND; //  
  ChannelsPanel : HWND; //     
  ChannelWindow : HWND; //      ""
  HookHandle : HHOOK = 0;
  btnTestButton : TbtnTestButton;
implementation

{$R *.dfm}


function PluginInit(dwThisPluginID : DWORD; plInfo : PPluginInfo; func1 : TtypeClCommFortProcess; func2 : TtypeClGetData) : BYTE;
begin
  dwPluginID := dwThisPluginID;
  plInfo^.strPluginName        := PLUGIN_NAME;
  plInfo^.strPluginDescription := PLUGIN_DESCRIPTION;
  plInfo^.strPluginVersion     := PLUGIN_VERSION;
  CommFortProcess              := func1;
  CommFortGetData              := func2;
  ChannelsCount := 0;
  Result := 0;

  //        
  if not Assigned(btnTestButton) then
    begin
      btnTestButton := TbtnTestButton.Create(nil);
      with btnTestButton do
        begin
          ParentWindow := FindWindow('TfChatClient', nil);
          Left := 4;
          Top := 325;
          Width := 45;
          Height := 45;
          Caption := 'Hello';
          //      OnClick  ,       OnMouseUp
          btnTestButton.OnMouseUp := TbtnTestButton.HelloOnMouseUp;//Event;
        end;
    end;
end;

class procedure TbtnTestButton.HelloOnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ShowMessage('Hello World!');
end;


function PluginProcess(dwMessageID : DWORD; bMessage : PString; dwMessageLength : DWORD) : BYTE;
var Msg: TStringStream;
begin
  Msg := TStringStream.Create(String(bMessage));
  Msg.Size := dwMessageLength;
  Msg.Position := 0;
  case dwMessageID of
    PM_PLUGIN_USERS_LIST          :  ChannelsCount := 0;
    PM_PLUGIN_USERSINCHANEL_LIST  :  pUsrsInChan(Msg);
  end;
  Result := 0;
  FreeAndNil(Msg);
end;

function CommFortAskData(AskType : Byte) : String;
var Size : Dword;
begin
  Result := '';
  SetLength(Result, 100);
  try
    Size := CommFortGetData(AskType, Pchar(Result), 100);
    SetLength(Result, Size);
  except
  end;
end;

function PluginTerminate : BYTE;
var Rect : TRect;
begin
  if Assigned(btnTestButton) then
    FreeAndNil(btnTestButton);
  Result := 0;
  if Assigned(frmStickyForm) then
    begin
      FreeAndNil(frmStickyForm);
      //        .
      GetWindowRect(ChannelsPanel, Rect);
      MoveWindow(ChannelWindow, 0, 0, Rect.Right - Rect.Left, Rect.Bottom - Rect.Top, True);
    end;
end;

procedure PluginShowOptions; stdcall;
begin
  ShowMessage('  ');
end;

procedure PluginShowAbout; stdcall;
begin
  ShowMessage('Sticky Null Plugin. Copyright  2009 by -=SJ=-');
end;

procedure TfrmStickyForm.FormDestroy(Sender: TObject);
begin
  //     
  if HookHandle <> 0 then
    UnhookWindowsHookEx(HookHandle);
  HookHandle := 0;
  Inherited;
end;

function WndHook(CODE, WParam, LParam: DWORD): DWORD; stdcall;
var Struct : CWPSTRUCT;
    WindowPos1 : WINDOWPOS;
    Rect : TRect;
begin
  //     Struct
  CopyMemory(@Struct, Pointer(LParam), SizeOf(CWPSTRUCT));
  //      
  if (Struct.hwnd = ChannelWindow) and (Struct.message = WM_SIZE) then
    begin
      //     ""   .     .
      GetWindowRect(ChannelsPanel, Rect);
      frmStickyForm.Width := Rect.Right - Rect.Left;
      frmStickyForm.Height := Rect.Bottom - Rect.Top - STICKY_CHANNEL_HEIGHT;
      MoveWindow(ChannelWindow, 0, frmStickyForm.Height, frmStickyForm.Width, STICKY_CHANNEL_HEIGHT, True);
    end;
  //           
  if (Struct.hwnd = ChannelWindow) and (Struct.message = WM_DESTROY) then
    begin
      FreeAndNil(frmStickyForm);
    end;
  //     $A100,           
  if (Struct.hwnd = ChatWindow) and (Struct.message = $A100)and not(IsWindowVisible(ChannelWindow)) then
    begin
      frmStickyForm.Visible := False;
    end;
  //       .
  if (Struct.hwnd = ChannelWindow) and (Struct.message = WM_WINDOWPOSCHANGED) then
    begin
      CopyMemory(@WindowPos1, Pointer(Struct.lParam), SizeOf(WINDOWPOS));
      if WindowPos1.flags = 6295 then
        frmStickyForm.Visible := False;
      if WindowPos1.flags = 6231 then
        frmStickyForm.Visible := True;
    end;
  //   
  Result := CallNextHookEx(HookHandle, code, WParam, LParam);
end;

procedure pUsrsInChan(Msg : TStringStream);
var CnlName : String;
    i, j : Integer;
    Rect : TRect;
    HWNDArr : array of HWND;

begin
  Msg.Read(i,4);
  CnlName := Msg.ReadString(i);

  if (CnlName = STICKY_CHANNEL_NAME) then
    begin
      //   
      ChatWindow := FindWindow('TfChatClient', nil);
      ChannelsPanel  := FindWindowEx(ChatWindow, 0, 'TPanel', nil);
      ChannelWindow := FindWindowEx(ChannelsPanel, 0, 'TRichView', nil);
      //          
      if (ChatWindow = 0) or (ChannelsPanel = 0) or (ChannelWindow = 0) then
        Exit;
      if not Assigned(frmStickyForm) then
        frmStickyForm := TfrmStickyForm.Create(nil);
      if (CommFortAskData(11) = CnlName) then
        begin
          //    ,            
          while not(IsWindowVisible(ChannelWindow)) and (ChannelWindow <> 0) do
            begin
              ChannelWindow := FindWindowEx(ChannelsPanel, ChannelWindow, 'TRichView', nil);
            end;
          if ChannelWindow = 0 then
            begin
              FreeAndNil(frmStickyForm);
              exit;
            end;
        end
      else
        begin
          //                    
          SetLength(HWNDArr, 1);
          HWNDArr[0] := ChannelWindow;
          while ChannelWindow <> 0 do
            begin
              ChannelWindow := FindWindowEx(ChannelsPanel, ChannelWindow, 'TRichView', nil);
              if ChannelWindow <> 0 then
                begin
                  j := Length(HWNDArr);
                  SetLength(HWNDArr, j + 1);
                  HWNDArr[j] := ChannelWindow;
                end;
            end;
          //          
          //      
          ChannelWindow := HWNDArr[Length(HWNDArr) - ChannelsCount - 2];
        end;
      //    
      frmStickyForm.ParentWindow := ChannelsPanel;
      // 
      frmStickyForm.BorderStyle := bsNone;
      //      
      frmStickyForm.Left := 0;
      frmStickyForm.Top := 0;
      GetWindowRect(ChannelsPanel, Rect);
      frmStickyForm.Width := Rect.Right - Rect.Left;
      frmStickyForm.Height := Rect.Bottom - Rect.Top - STICKY_CHANNEL_HEIGHT;
      MoveWindow(ChannelWindow, 0, frmStickyForm.Height, frmStickyForm.Width, STICKY_CHANNEL_HEIGHT, True);
    end
  else
    begin
      ChannelsCount := ChannelsCount + 1
    end;
  //     
  if HookHandle = 0 then
    HookHandle := SetWindowsHookEx(WH_CALLWNDPROC, @WndHook, 0, GetCurrentThreadId);
  //        
  if IsWindowVisible(ChannelWindow) then
    frmStickyForm.Show;
end;

end.
